/**================================================================================================
Hochschule Luzern - Technik & Architektur                                  Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                    http://hslu.ximit.ch
---------------------------------------------------------------------------------------------------
Name        : getch.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-07v1.0
Description : Taschenrechner polnische Notation
              getch: Zeichen holen mit Buffer
			  ungetch: Zeichen wieder zurueckstellen wenn zuviel geholt
=================================================================================================*/

#include <stdio.h>

/* Konstanten */
#define BUFSIZE 100		/* Buffer Size */

/* Globale Variablen */
char buf[BUFSIZE];		/* Buffer */
int bufp = 0;			/* Buffer-Pointer */


/* getch: Zeichen holen mit Buffer */
int getch(void) {
	// return (bufp > 0) ? buf[--bufp] : getchar();
	if (bufp > 0) {
		return buf[--bufp];
	} else {
		return getchar();
	}
}

/* ungetch: Zeichen wieder zurueckstellen wenn zuviel geholt */
void ungetch(int c){
	if (bufp >= BUFSIZE) {
        printf("Error ungetch(): Zu viele Zeichen\n");
	} else {
        buf[bufp++] = c;
	}
}
