/**================================================================================================
Hochschule Luzern - Technik & Architektur                                  Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                    http://hslu.ximit.ch
---------------------------------------------------------------------------------------------------
Name        : stack.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-07v1.0
Description : Taschenrechner polnische Notation
              Implementiert den Stack
=================================================================================================*/

#include <stdio.h>
#include "calc.h"		/* Eigene Methoden einbinden */

/* Konstanten */
#define MAXVAL 100		/* Stack Size */

/* Globale Variablen */
double val[MAXVAL];		/* Stack */
int sp = 0;				/* Stack-Pointer */

/* push: f auf den Stack bringen */
void push(double f) {
	if (sp < MAXVAL) {
		val[sp++] = f;
	} else {
		printf("Error: Stack ist voll! %g kann nicht eingefuegt werden...\n", f);
	}
}

/*pop: Wert von Stack holen und liefern */
double pop(void) {
	if (sp > 0) {
		return val[--sp];
	} else {
		printf("Error: Stack ist leer!\n");
		return 0.0;
	}
}
