/**================================================================================================
Hochschule Luzern - Technik & Architektur                                  Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                    http://hslu.ximit.ch
---------------------------------------------------------------------------------------------------
Name        : main.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-07v1.0
Description : Message Queue
              Machen Sie eine einfache Message Queue, welche mind. die drei Funktionen
			  initialize, enqueue and dequeue enthlt. Die Messages sollen aus einem Integerwert
			  bestehen. enqueue schreibt die neue Message an das Ende der Queue, dequeue liest
			  das nchste Element aus der Queue. Falls keine Messages vorhanden sind soll die
			  Funktion dequeue blockieren.
=================================================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include "queue.h"


/**
 * The main procedure to run the application.
 * @param argc Number of command line arguments
 * @param argv The forwarded command line arguments
 * @return Application return (error) code
 */
int main(int argc, char** argv)
{

	// init MessageQueue 
	MessageQueue* aQueue = initialize();
	int i;

	// Write Queue
	for(i=0; i<10; i++) {
		printf("in:  %d\n",enqueue(aQueue,i));
	}
	printf("------------------------------------------------------\n");

	// Read Queue
	for(i=0; i<5; i++) {
		printf("out: %d\n",dequeue(aQueue));
	}
	printf("------------------------------------------------------\n");

	// Write Queue
	for(i=500; i>490; i--) {
		printf("in:  %d\n",enqueue(aQueue,i));
	}
	printf("------------------------------------------------------\n");

	// Read Queue
	for(i=0; i<15; i++) {
		printf("out: %d\n",dequeue(aQueue));
	}
	printf("------------------------------------------------------\n");


	// DEAD LOCK
	// Read Queue --> Queue is empty!
	printf("out: %d\n",dequeue(aQueue));

	return(EXIT_SUCCESS);
}
