/**================================================================================================
Hochschule Luzern - Technik & Architektur                                  Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                    http://hslu.ximit.ch
---------------------------------------------------------------------------------------------------
Name        : queue.h
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-07v1.0
Description : Message Queue
=================================================================================================*/


typedef struct Node {
  struct Node* next;		// next node pointer
  int data;			        // value
} Node;

typedef struct MessageQueue {
  Node* head;				// first node pointer
  Node* rear;				// rear node pointer
  int size;					// queue size
} MessageQueue;


/**
 * Allocate Memory for the Queue
 * @return Pointer for the new Queue
 */
MessageQueue* initialize();

/**
 * Add a new Value to the Queue
 * @param aQueue Pointer to the Queue
 * @param aValue Value to add
 * @return Value that has been added
 */
int enqueue(MessageQueue *aQueue, int aValue);

/**
 * Get a Value from the Queue
 * @param aQueue Pointer to the Queue
 * @return Value from the Queue
 */
int dequeue(MessageQueue *aQueue);
